﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    cerr << "Enter bin count: ";
    cin >> in.bin_count;
    sort(begin(in.numbers), end(in.numbers));
    in.numbers.erase(unique(begin(in.numbers), end(in.numbers)), end(in.numbers));
    number_count = in.numbers.size();
    return in;
}

int main() {
    Input in = input_data();
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    vector<size_t> bins(in.bin_count);
    double min = in.numbers[0];
    double max = in.numbers[0];
    for (double x : in.numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
    size_t max_count = 0;
    double bin_size = (max - min) / in.bin_count;
    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < in.bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= in.numbers[i]) && (in.numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }   
        }
        if (!found) {
            bins[in.bin_count - 1]++;
        }
        for (size_t i = 0; i < in.bin_count; i++) {
            if (bins[i] > max_count) {
                max_count = bins[i];
            }
        }
    }
    double kof = double(MAX_ASTERISK) / max_count;
    if (kof > 1) {
        kof = 1;
    }
    for (size_t bin : bins) {
        if (bin < 100) {
            cout << " ";
        }
        if (bin < 10) {
            cout << " ";
        }
        cout << bin << "|";
        for (size_t i = 0; i < size_t(bin * kof); i++) {
            cout << "*";
        }

        cout << endl;
    }
    return 0;
}